--- old/usr/src/uts/common/syscall/open.c	Tue Apr  2 01:24:37 2013
+++ new/usr/src/uts/common/syscall/open.c	Tue Apr  2 01:24:37 2013
@@ -27,6 +27,9 @@
 /*	  All Rights Reserved  	*/
 
 /*
+ * Copyright (c) 2013, OmniTI Computer Consulting, Inc. All rights reserved.
+ */
+/*
  * Portions of this source code were derived from Berkeley 4.3 BSD
  * under license from the Regents of the University of California.
  */
@@ -226,6 +229,9 @@
 					 * falloc reserved.
 					 */
 					setf(fd, fp);
+					if ((filemode & FCLOEXEC) != 0) {
+						f_setfd(fd, FD_CLOEXEC);
+					}
 					return (fd);
 				} else {
 					/*
@@ -252,6 +258,9 @@
 					fp->f_count++;
 					mutex_exit(&fp->f_tlock);
 					setf(fd, fp);
+					if ((filemode & FCLOEXEC) != 0) {
+						f_setfd(fd, FD_CLOEXEC);
+					}
 					releasef(dupfd);
 				}
 				return (fd);
